----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:39:40 06/02/2015 
-- Design Name: 
-- Module Name:    SPIconf - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
-- June-3-2015
-- SPI mode fixed as 1
-- 6 MPAs are daisy chained, length for each MPA increased by one because of the dummy bit added at the LSB
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity SPIconf is
    Port ( reset : in  STD_LOGIC;
					 sysclk : in  STD_LOGIC;
					 is_MPA_R : IN std_logic;
					 start : in  STD_LOGIC;
					 conf_en : out  STD_LOGIC;
           conf_clk : out  STD_LOGIC;
					 conf_din_p : in  STD_LOGIC;
           conf_din_n : in  STD_LOGIC;
					 conf_dout_p : out  STD_LOGIC;
           conf_dout_n : out  STD_LOGIC;
           conf_done : out  STD_LOGIC;
					 nMPA_maxsub1 : in std_logic_vector(2 downto 0);
					 nMPA : out std_logic_vector(2 downto 0);
					 skipMPA0 : out  STD_LOGIC;
           ipb_clk : in  STD_LOGIC;
					 ipb_write : in std_logic;
					 ipb_strobe : in std_logic;
					 ipb_addr : in std_logic_vector(15 downto 0);
					 ipb_wdata : in std_logic_vector(31 downto 0);
           ipb_rdata : out  STD_LOGIC_VECTOR (31 downto 0));
end SPIconf;

architecture Behavioral of SPIconf is
constant MODE : std_logic_vector(1 downto 0) := "01";
constant zero : std_logic_vector(31 downto 0) := (others =>'0');
signal conf_clkp : std_logic := '0';
signal conf_en_i : std_logic := '0';
signal conf_en_q : std_logic := '0';
signal conf_din : std_logic := '0';
signal conf_dout : std_logic := '0';
signal conf_doutp : std_logic := '0';
signal skipMPA0_i : std_logic := '0';
signal nMPA_i : std_logic_vector(2 downto 0) := "110";
signal nMPAsub1 : std_logic_vector(2 downto 0) := (others =>'0');
signal MPA_cnt : std_logic_vector(2 downto 0) := (others =>'0');
signal CLKCONF_DIV : std_logic_vector(3 downto 0) := (others =>'0');
--signal CLKCONF_DIV : std_logic_vector(3 downto 0) := x"4";
signal cnt : std_logic_vector(3 downto 0) := (others =>'0');
signal CLKCONF_o : std_logic := '0';
signal GO : std_logic := '0';
signal GO_q : std_logic := '0';
signal send : std_logic := '0';
signal rec : std_logic := '0';
signal en_rec : std_logic := '0';
signal en_send : std_logic := '0';
signal toggle : std_logic := '0';
signal toggle_q : std_logic := '0';
--signal strobe : std_logic_vector(2 downto 0) := (others =>'0');
signal wbuf_we : std_logic_vector(3 downto 0) := (others =>'0');
signal wbuf_addra : std_logic_vector(9 downto 0) := (others =>'0');
signal wbuf_ra : std_logic_vector(14 downto 0) := (others =>'0');
signal wbuf_DOA : std_logic_vector(31 downto 0) := (others =>'0');
signal wbuf_DOB : std_logic_vector(0 downto 0) := (others =>'0');
signal rbuf_DO : std_logic_vector(31 downto 0) := (others =>'0');
signal rbuf_DI : std_logic_vector(0 downto 0) := (others =>'0');
signal rbuf_wa : std_logic_vector(14 downto 0) := (others =>'0');
signal rbuf_we : std_logic := '0';
attribute IOB : string;
attribute IOB of conf_en, conf_clk, conf_dout, rbuf_DI : signal is "true";
begin
nMPA <= nMPA_i;
skipMPA0 <= skipMPA0_i;
nMPAsub1 <= "000" when nMPA_i(2 downto 1) = "00" else nMPA_i - 1;
conf_en <= conf_en_i;
i_conf_din_buf: IBUFDS generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_25") port map(i => conf_din_p, ib => conf_din_n, o => conf_din);
i_conf_dout_obuf : OBUFDS generic map (IOSTANDARD => "LVDS_25") port map (O => conf_dout_p, OB => conf_dout_n, I => conf_dout);
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		if(rec = '1')then
			rbuf_DI(0) <= conf_din;
		end if;
		if(skipMPA0_i = '0')then
		  if(send = '0')then
			  conf_dout <= conf_doutp;
			end if;
		elsif(send = '1')then
			conf_dout <= wbuf_DOB(0);
		end if;
		if(send = '1')then
			conf_doutp <= wbuf_DOB(0);
		end if;
		conf_clk <= conf_clkp;
		conf_clkp <= CLKCONF_o;
		if(ipb_addr = x"0000" and ipb_wdata(2) = '1' and ipb_write = '1' and ipb_strobe = '1')then
			wbuf_ra <= ipb_wdata(4 downto 3) & nMPA_maxsub1 & "1100010100";
		elsif(send = '1')then
			if(wbuf_ra(4 downto 0) = "00000")then
				if(wbuf_ra(9 downto 5) = "00000")then
					wbuf_ra(9 downto 5) <= "11000";
					wbuf_ra(12 downto 10) <= wbuf_ra(12 downto 10) - 1;
				else
					wbuf_ra(9 downto 5) <= wbuf_ra(9 downto 5) - 1;
				end if;
				if(wbuf_ra(9 downto 6) = x"0")then
					if(wbuf_ra(5) = '1')then
						wbuf_ra(4 downto 0) <= "11111";
					else
						wbuf_ra(4 downto 0) <= "10100";
					end if;
				else
					wbuf_ra(4 downto 0) <= "10011";
				end if;
			else
				wbuf_ra(4 downto 0) <= wbuf_ra(4 downto 0) - 1;
			end if;
		end if;
		if(start = '1')then
			rbuf_wa <= wbuf_ra(14 downto 13) & nMPAsub1 & "1100010011";
		elsif(rbuf_we = '1')then
			if(rbuf_wa(4 downto 0) = "00000")then
				if(rbuf_wa(9 downto 5) = "00000")then
					rbuf_wa(9 downto 5) <= "11000";
					rbuf_wa(12 downto 10) <= rbuf_wa(12 downto 10) - 1;
				else
					rbuf_wa(9 downto 5) <= rbuf_wa(9 downto 5) - 1;
				end if;
				if(rbuf_wa(9 downto 6) = x"0")then
					if(rbuf_wa(5) = '1')then
						rbuf_wa(4 downto 0) <= "11111";
					else
						rbuf_wa(4 downto 0) <= "10100";
					end if;
				else
					rbuf_wa(4 downto 0) <= "10011";
				end if;
			else
				rbuf_wa(4 downto 0) <= rbuf_wa(4 downto 0) - 1;
			end if;
		end if;
		if(start = '1')then
			MPA_cnt <= nMPA_maxsub1;
		elsif(send = '1' and wbuf_ra(9 downto 0) = "0000000000")then
			MPA_cnt <= MPA_cnt - 1;
		end if;
	end if;
end process;
process(ipb_clk,reset)
begin
	if(reset = '1')then
		nMPA_i   <= "110";
		skipMPA0_i    <= '0';
		cnt   <= (others =>'0');
		GO    <= '0';
		GO_q    <= '0';
		CLKCONF_o <= '0';
		send     <= '0';
		rec      <= '0';
		en_rec <= '0';
		en_send <= '0';
		rbuf_we <= '0';
		conf_en_i <= '0';
		conf_en_q <= '0';
		conf_done <= '0';
	elsif(ipb_clk'event and ipb_clk = '1')then
		if(ipb_addr(15 downto 13) = "001" and ipb_addr(12) = IS_MPA_R and ipb_addr(11 downto 0) = x"001" and ipb_write = '1' and ipb_strobe = '1')then
			nMPA_i <= ipb_wdata(2 downto 0);
			skipMPA0_i <= ipb_wdata(3);
		end if;
		if(start = '1')then
			GO <= '1';
		elsif(or_reduce(cnt(3 downto 1)) = '0' and en_rec = '0' and (MODE(0) = '1' or en_rec = '0'))then
			GO <= '0';
		end if;
		GO_q <= GO;
		if(start = '1' or (GO = '0' and GO_q = '1'))then
			cnt <= CLKCONF_DIV;
		elsif(GO = '1' or or_reduce(cnt(3 downto 1)) = '1')then
			if(or_reduce(cnt(3 downto 1)) = '0')then
				cnt <= CLKCONF_DIV;
			else 
				cnt <= cnt - 1;
			end if;
		end if;
		if(start = '1')then
			en_rec <= '1';
		elsif(or_reduce(cnt(3 downto 1)) = '0' and en_send = '0' and xor_reduce(MODE & CLKCONF_o) = '0')then
			en_rec <= '0';
		end if;
		if(start = '1')then
			en_send <= '1';
		elsif(or_reduce(MPA_cnt) = '0' and or_reduce(cnt(3 downto 1)) = '0' and wbuf_ra(9 downto 0) = "0000000000" and xor_reduce(MODE & CLKCONF_o) = '1')then
			en_send <= '0';
		end if;
		if(or_reduce(cnt(3 downto 1)) = '0')then
			if(en_rec = '0')then
				CLKCONF_o <= MODE(1);
			else
				CLKCONF_o <= not CLKCONF_o;
			end if;
		end if;
		rec <= conf_clkp and en_rec;
--		if(or_reduce(cnt(3 downto 1)) = '0' and en_rec = '1' and xor_reduce(MODE & CLKCONF_o) = '0')then
--			rec <= '1';
--		else
--			rec <= '0';
--		end if;
		if(start = '1' and MODE(0) = '0')then
			send <= '1';
		elsif(or_reduce(cnt(3 downto 1)) = '0' and en_send = '1' and xor_reduce(MODE & CLKCONF_o) = '1')then
			send <= '1';
		else
			send <= '0';
		end if;
		rbuf_we <= rec;
		conf_en_i <= start or GO or GO_q or or_reduce(cnt(3 downto 1));
		conf_en_q <= conf_en_i;
		conf_done <= not conf_en_i and conf_en_q;
	end if;
end process;
process(ipb_clk,reset)
begin
	if(reset = '1')then
		toggle <= '0';
	elsif(ipb_clk'event and ipb_clk = '1')then
		toggle <= not toggle;
	end if;
end process;
process(sysclk,reset)
begin
	if(reset = '1')then
		toggle_q <= '0';
--		strobe <= (others => '0');
		wbuf_we <= (others => '0');
	elsif(sysclk'event and sysclk = '1')then
		toggle_q <= toggle;
		if(ipb_addr(15 downto 13) = "001" and ipb_addr(12) = IS_MPA_R and ipb_addr(11 downto 10) = "01" and ipb_write = '1' and ipb_strobe = '1' and toggle /= toggle_q)then
			wbuf_we <= x"f";
		else
			wbuf_we <= x"0";
		end if;		
	end if;
end process;
i_wbuf : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "VIRTEX6", -- Target device: "VIRTEX5", "VIRTEX6", "SPARTAN6" 
      READ_WIDTH_A => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 1,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_A => 32, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 1) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
    port map (
      DOA => wbuf_DOA,       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => wbuf_DOB,       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => ipb_addr(9 downto 0),   -- Input port-A address, width defined by Port A depth
      ADDRB => wbuf_ra,   -- Input port-B address, width defined by Port B depth
      CLKA => sysclk,     -- 1-bit input port-A clock
      CLKB => ipb_clk,     -- 1-bit input port-B clock
      DIA => ipb_wdata,       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => "0",       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => '1',       -- 1-bit input port-B enable
      REGCEA => '0', -- 1-bit input port-A output register enable
      REGCEB => '0', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => wbuf_we,       -- Input port-A write enable, width defined by Port A depth
      WEB => "0"       -- Input port-B write enable, width defined by Port B depth
   );
i_rbuf : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "VIRTEX6", -- Target device: "VIRTEX5", "VIRTEX6", "SPARTAN6" 
      WRITE_WIDTH => 1,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 32)     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
    port map (
      DO => rbuf_DO,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => rbuf_DI,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => ipb_addr(9 downto 0), -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '0',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => "1",         -- Input write enable, width defined by write port depth
      WRADDR => rbuf_wa, -- Input write address, width defined by write port depth
      WRCLK => ipb_clk,   -- 1-bit input write clock
      WREN => rbuf_we      -- 1-bit input write port enable
   );
process(ipb_addr)
begin
	if(ipb_addr(15 downto 13) = "001" and ipb_addr(12) = IS_MPA_R and ipb_addr(11 downto 4) = x"00")then
		case ipb_addr(3 downto 0) is
			when x"0" => ipb_rdata <= zero(31 downto 1) & GO;
			when x"1" => ipb_rdata <= zero(31 downto 4) & skipMPA0_i & nMPA_i;
			when x"3" => ipb_rdata <= zero(31 downto 15) & wbuf_ra;
			when x"4" => ipb_rdata <= zero(31 downto 15) & rbuf_wa;
			when others => ipb_rdata <= (others => '0');
		end case;
	elsif(ipb_addr(15 downto 13) = "001" and ipb_addr(12) = IS_MPA_R and ipb_addr(11 downto 10) = "01")then
		ipb_rdata <= wbuf_DOA;
	elsif(ipb_addr(15 downto 13) = "001" and ipb_addr(12) = IS_MPA_R and ipb_addr(11 downto 10) = "10")then
		ipb_rdata <= rbuf_DO;
	else
		ipb_rdata <= (others => '0');
	end if;
end process;
end Behavioral;

